<template>
  <v-card :class="`hud hud-${ positionX } hud-${ positionY }`">
    <v-form>
      <v-card-text>
        <v-row
          no-gutters
          justify="space-between"
        >
          <v-col
            cols="auto"
            class="d-flex mr-3"
          >
            <v-progress-circular
              v-if="isRealTimeLocal"
              :value="timeSpent"
              color="primary"
              size="22"
              style="align-self: center"
            />
          </v-col>
          <v-col cols="auto">
            <metrocheck-datetime-displayed-picker
              :label="false"
              :disabled="isRealTimeLocal"
            />
          </v-col>
        </v-row>
      </v-card-text>
      <v-alert
        v-if="specialShownTime"
        type="warning"
        dense
        class="mb-0"
        style="border-top-right-radius: 0; border-top-left-radius: 0;"
      >
        Showing positions at {{ specialShownTime }}
      </v-alert>
    </v-form>
  </v-card>
</template>

<script>
  import MetrocheckDatetimeDisplayedPicker from '../DatetimeDisplayedPicker'
  import { mapState } from 'vuex'
  import { mutations } from '../../store/constants'
  import config from '../../../config'
  import mapWorker from '../../workers/positions'

  // noinspection JSUnusedGlobalSymbols
  export default {
    name: 'MetrocheckHud',
    components: { MetrocheckDatetimeDisplayedPicker },

    props: {
      top: { required: false, type: null },
      bottom: { required: false, type: null },
      left: { required: false, type: null },
      right: { required: false, type: null },
      displayedLines: { required: true, type: Array },
    },

    data: function () {
      return {
        playSpeed: 1,
        realtimeIntervalId: null,
        timeTicks: 0,
        // Shown as a warning
        specialShownTime: null,
      }
    },

    computed: {
      ...mapState(['displayedDatetime']),

      positionY: function () {
        return this.$props.bottom ? 'bottom' : 'top'
      },

      positionX: function () {
        return this.$props.left ? 'left' : 'right'
      },

      isRealTimeLocal: {
        get () {
          return true
        },
        set () {
          console.warn('isRealTimeLocal cannot be changed')
        },
      },

      timeSpent: function () {
        return Math.round(100 - this.timeTicks / config.api.fetchIntervals.positions * 100)
      },
    },

    watch: {
      isRealTime: function (n) {
        // console.log('isRealTime changed.', n)
        this[`${n ? 'start' : 'stop'}Realtime`]()
      },
    },

    async created () {
      mapWorker.worker.addEventListener('message', this.handleWorkerMessage)
    },

    mounted () {
      if (this.isRealTimeLocal) {
        this.startRealtime()
      }
    },

    beforeDestroy () {
      this.stopRealtime()
    },

    methods: {

      handleWorkerMessage: function (event) {
        // console.debug('hud handleWorkerMessage : %O', event.data)
        switch (event.data.type) {
          case 'DISPLAY_MESSAGE':
            if (!this.specialShownTime) {
              const d = new Date(this.displayedDatetime - config.api.fetchIntervals.positions)
              this.specialShownTime = d.toLocaleTimeString()
            }
            break
          case 'DISPLAY_POSITIONS':
            if (this.specialShownTime) this.specialShownTime = null
            break
        }
      },

      startRealtime: function () {
        // console.debug('startRealtime()')
        this.now()
        this.realtimeIntervalId = setInterval(this.tickTime, 1000)
      },

      stopRealtime: function () {
        // console.debug('stopRealtime()')
        clearInterval(this.realtimeIntervalId)
      },

      tickTime: function () {
        this.timeTicks += 1000
        if (++this.timeTicks >= config.api.fetchIntervals.positions) {
          this.timeTicks = 0
          this.now()
        }
      },

      // Set datetime to now
      now: function () {
        this.$store.commit(mutations.SET_DISPLAYED_DATETIME, Date.now() - config.api.fetchIntervals.positions)
      },
    },
  }
</script>

<!--suppress CssUnusedSymbol -->
<style scoped>
  .hud {
    position: absolute;
    z-index: 700;
    min-width: 20vw;
  }

  .hud-right {
    right: 3em;
  }

  .hud-top {
    top: 1em;
  }

  .hud--date {
    cursor: pointer;
  }

  .hud--date:hover {
    background-color: #333;
  }
</style>
